function u=fem1d_Loesung(coordinates,elements,dirichlet,a,b,c,f,u_d)
% Angewandte Numerik 2, WS 2013/2014
% Blatt 11, Aufgabe 26: Finite-Elemente_Methode in 1D mit Hutfunktionen
%
% fem1d berechnet die Finite-Elemente-Loesung
%
% Loesungsvorschlag


%
% WAS STEHT IN COORDINATES, ELEMENTS und DIRICHLET?
%

N=size(elements,1);

%   coordinates:    enthaelt die Koordinaten aller N+1 Knoten
%   elements:       enthaelt zu allen N Elementen
%                   die zum jeweiligen Element gehoerenden Knoten
%   dirichlet:      enthaelt die Knoten,
%                   fuer die Dirichlet-Randbedingungen gelten

A=sparse(N+1,N+1);
B=sparse(N+1,N+1);
C=sparse(N+1,N+1);
rhs=zeros(N+1,1);
u=zeros(N+1,1);

% Steifigkeitsmatrix aufstellen
% Schleife ueber die Elemente, nicht ueber Basisfunktionen!!!
for j=1:N
  x=coordinates(elements(j,:));
  %
  % HIER ASSEMBLIERUNG VON A, B UND C EINFUEGEN
  %
  A(elements(j,:),elements(j,:))=A(elements(j,:),elements(j,:))+...
    a/(x(2)-x(1))*[1 -1;-1 1];
  B(elements(j,:),elements(j,:))=B(elements(j,:),elements(j,:))+...
    b/2*[-1 1;-1 1];
  C(elements(j,:),elements(j,:))=C(elements(j,:),elements(j,:))+...
    c*(x(2)-x(1))/6*[2 1;1 2];   
end

% Rechte Seite
for j=1:N
  x=coordinates(elements(j,:));
  %
  % HIER ASSEMBLIERUNG DER RHS EINFUEGEN
  %
  rhs([elements(j,1);elements(j,2)])=rhs([elements(j,1);elements(j,2)])+...
   (x(2)-x(1))/2*f((x(1)+x(2))/2);
end

% Dirichlet Bedingungen
u(dirichlet)=u_d;

% Finite-Elemente-Loesung berechnen
M=A+B+C;        % Gesamte Matrix

rhs=rhs-M*u;    % rechte Seite unter Beruecksichtigung der Randbedingungen

freenodes=setdiff(1:size(elements,1)+1,dirichlet); % WAS IST FREENODES?
                % freenodes enthaelt alle Knoten,
                % die nicht zum Dirichlet-Rand gehoeren.

u(freenodes)=M(freenodes,freenodes)\rhs(freenodes);
