function solve_1dfem_Loesung
% Angewandte Numerik 2, WS 2013/2014
% Blatt 11, Aufgabe 26: Finite-Elemente_Methode in 1D mit Hutfunktionen
%
% solve_1dfem loest das 1d-Problem
%       -au''+bu'+cu = f in (0,1)
%       a,b,c konstant


clear all;
close all;

% Netz laden
load coordinates.dat
load elements.dat
load dirichlet.dat

teil = 'a';

switch teil
  case 'a'
    a=1;b=0;c=0;     u_d=[0;0]; f = @(x) 1; u_exact = @(x) 1/2*(-x^2+x);
  case 'b'
    a=1;b=0;c=0;     u_d=[0;1]; f = @(x) 1; u_exact = @(x) -1/2*x^2+3/2*x;
  case 'c'
    a=1;b=0;c=0;     u_d=[0;0]; f = @(x) x; u_exact = @(x) 1/6*x*(-x^2+1);
  case 'd'
    a=1;b=0;c=1/100; u_d=[0;0]; f = @(x) 1; u_exact = @(x) -100*(exp(-x/10+1/10)-exp(1/10)+exp(x/10)-1)/(1+exp(1/10)); 
  case 'e'
    a=1;b=1/10;c=0;  u_d=[0;0]; f = @(x) 1; u_exact = @(x) 10*(-exp(x/10)+x*exp(1/10)-x+1)/(exp(1/10)-1);
  case 'f'
    a=1;b=0;c=100;   u_d=[0;0]; f = @(x) 1; u_exact = @(x) -0.01*(exp(-10*x+10)-exp(10)+exp(10*x)-1)/(1+exp(10));
end

% Exakte Loesung plotten
fplot(u_exact,[0,1],'r--'),hold on


for k=0:3
  % Finite-Elemente-Loesung berechnen
  u=fem1d_Loesung(coordinates,elements,dirichlet,a,b,c,f,u_d);
  % Finite-Elemente-Loesung plotten
  plot(coordinates(elements)',u(elements)','k-');
  hold on;
  pause;
  % Gitter verfeinern
  coordinates=[coordinates;sum(coordinates(elements),2)/2];
        % Die Mittelpunkte jedes alten Elements sollen neue Knoten werden
        % Die Nummerierung der neuen Knoten beginnt im Anschluss an die
        % Nummerierung der alten Knoten. 
        % Die Koordinaten (Mittelpunkt des alten Elements) der neuen Knoten
        % werden berechnet.
        % Entsprechend der Nummerierung der neuen Knoten muessen sie hinten
        % an die Liste der bisherigen Koordinaten angefuegt werden.
  n=size(elements,1);
  elements=[[elements(:,1),(n+2:2*n+1)'];[(n+2:2*n+1)',elements(:,2)]];
        % Die neuen Elemente bestehen
        % entweder aus der linken Haelfte des alten Elements,
        %   also linker Knoten und neu berechneter Mittelpunkt
        %   (Nummerierung der neuen Knoten ab n+2 bis 2*n+1),
        % oder aus der rechten Haelfte des alten Elements,
        %   also neu berechneter Mittelpunkt und rechter Knoten.
end

% letztes Mal Finite-Elemente-Loesung berechnen
u=fem1d_Loesung(coordinates,elements,dirichlet,a,b,c,f,u_d);

% letztes Mal Finite-Elemente-Loesung plotten
plot(coordinates(elements)',u(elements)','k-'),hold on
